package org.netkernel.layer1.endpoint;

import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.representation.ByteArrayRepresentation;
import org.netkernel.layer0.representation.IBinaryStreamRepresentation;
import org.netkernel.layer0.representation.IHDSNode;
import org.netkernel.layer0.representation.IReadableBinaryStreamRepresentation;
import org.netkernel.layer0.representation.impl.HDSFactory;
import org.netkernel.module.standard.endpoint.StandardTransreptorImpl;
import org.w3c.dom.Node;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.InputStream;

public class BinaryStreamToReadable extends StandardTransreptorImpl
{
	
	public BinaryStreamToReadable()
	{	this.declareThreadSafe();
		this.declareFromRepresentation(IBinaryStreamRepresentation.class);
		this.declareToRepresentation( IReadableBinaryStreamRepresentation.class);
	}
	
	public void onTransrept(INKFRequestContext aContext) throws Exception
	{	
		IHDSNode result;
		IBinaryStreamRepresentation rawPrimary=(IBinaryStreamRepresentation)aContext.getThisRequest().getPrimary();
		ByteArrayOutputStream baos = new ByteArrayOutputStream(2048);
		rawPrimary.write(baos);
		baos.flush();
		ByteArrayRepresentation bar = new ByteArrayRepresentation(baos);
		aContext.createResponseFrom(bar);
	}
}