package org.netkernel.layer1.endpoint;

import java.io.UnsupportedEncodingException;

import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.nkf.NKFException;
import org.netkernel.layer0.representation.ByteArrayRepresentation;
import org.netkernel.layer0.representation.IReadableBinaryStreamRepresentation;
import org.netkernel.module.standard.endpoint.StandardTransreptorImpl;
import org.netkernel.urii.IIdentifier;

public class PrimitiveSerializer extends StandardTransreptorImpl
{
	public PrimitiveSerializer()
	{
		this.declareThreadSafe();

		this.declareFromRepresentation(IIdentifier.class);
		this.declareFromRepresentation(Byte.class);
		this.declareFromRepresentation(Short.class);
		this.declareFromRepresentation(Integer.class);
		this.declareFromRepresentation(Long.class);
		this.declareFromRepresentation(Float.class);
		this.declareFromRepresentation(Double.class);
		this.declareFromRepresentation(Boolean.class);
		
        this.declareToRepresentation(IReadableBinaryStreamRepresentation.class);    
        this.declareToRepresentation(String.class);    
	}
	
	public void onTransrept(INKFRequestContext aContext) throws NKFException, UnsupportedEncodingException
	{	Object in = aContext.sourcePrimary(Object.class);
		Class toClass=aContext.getThisRequest().getRepresentationClass();
		String rs=in.toString();
		if (toClass==String.class)
		{	aContext.createResponseFrom(rs);
		}
		else if (toClass.isAssignableFrom(ByteArrayRepresentation.class))
		{	ByteArrayRepresentation bar=new ByteArrayRepresentation(rs.getBytes("UTF-8"),"UTF-8");
			aContext.createResponseFrom(bar);
		}
	}	
}
