package org.netkernel.layer1.representation;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

import org.netkernel.layer0.representation.IReadableBinaryStreamRepresentation;
import org.netkernel.layer0.util.Utils;

public class FileRepresentation implements IReadableBinaryStreamRepresentation
{	private final File mFile;
	
	public FileRepresentation(File aFile) throws IOException
	{	mFile = aFile;
	}
	
	/** return the length of the resource */
	public int getContentLength()
	{	 return (int)mFile.length();
	}
	
	/** write the resource to the given output stream */
	public  void write(OutputStream aStream) throws IOException
	{	InputStream is = new FileInputStream(mFile);
		Utils.pipe(is,aStream);
	}
	
	/** get an input stream for the  resource */
	public synchronized InputStream getInputStream() throws IOException
	{	return new FileInputStream(mFile);
	}
	
	public String getEncoding()
	{	return null;
	}
}